package org.openjdk.gcbench.runtime.cmpxchg;

import org.openjdk.jmh.annotations.*;

import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;

@Warmup(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Measurement(iterations = 5, time = 1, timeUnit = TimeUnit.SECONDS)
@Fork(1)
@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.NANOSECONDS)
@Threads(1)
@State(Scope.Benchmark)
public class CasBarriersPrimitiveSuccess {

    AtomicInteger ai;

    Object t1, t2;

    int value;

    @Setup
    public void setup() {
        value = 42;
        ai = new AtomicInteger();
        ai.set(value);
    }

    @Benchmark
    @CompilerControl(CompilerControl.Mode.DONT_INLINE)
    public void test() {
        ai.compareAndSet(value, value);
    }

    /*
        i7 4790K, 4.0 Ghz, Linux x86_64, JDK 9 (Shenandoah, 2016-09-05)

            Benchmark         Mode  Cnt   Score   Error  Units

            # Shenandoah
            CasBarriers.test  avgt   25  16.418 ± 0.029  ns/op

            # G1
            CasBarriers.test  avgt   25  12.545 ± 0.041  ns/op

            # Parallel
            CasBarriers.test  avgt   25  12.526 ± 0.030  ns/op

        Analysis pending.
     */

}
